-- Copyright   :  (c) Vidas Daudaravicius 2012
-- License     :  BSD3-style (see LICENSE)
-- Version     : 0.1

module Files where

import System.Directory
import Data.Char
import qualified System.IO as IO

getFileName file = last $ splitOn' '/' $ takeWhile (/='.') file

splitOn' c ln = lines $ map (\ x -> if x==c then '\n' else x) $ ln

------------------------------------------------------
hasExtention file [] = True
hasExtention file ext
          | (drop (length file - length ext) file) == ext = True
          | otherwise = False
------------------------------------------------------
getFiles dirs ext = getFiles'' dirs ext []

------------------------------------------------------
getFiles'' [] ext ls = return ls
getFiles'' (dir:dirs) ext ls = do
            fdo <- doesDirectoryExist(dir)
            if(fdo) then do
                        fs <- getDirectoryContents(dir)
                        r <- return [dir++"/"++f | f<-fs , f /= "." , f /= ".." ]
                        getFiles'' (dirs++r) ext ls
                    else do
                        d <- doesFileExist(dir)
                        if(d && hasExtention dir ext )
                               then getFiles'' dirs ext $! (dir:ls)
                               else getFiles'' dirs ext ls




removeFiles dir ext = do 
                         removeFiles'' dir ext

removeFiles' [] = return ()
removeFiles' (f:fs) = do 
                       removeFile f
                       removeFiles' fs 

------------------------------------------------------
removeFiles'' [] ext = return ()
removeFiles'' (dir:dirs) ext = do
            fdo <- doesDirectoryExist(dir)
            if(fdo) then do
                        fs <- getDirectoryContents(dir)
                        r <- return [dir++"/"++f | f<-fs , f /= "." , f /= ".." ]
                        removeFiles'' r ext
                        removeFiles'' (dirs) ext
                    else do
                        d <- doesFileExist(dir)
                        if(d && hasExtention dir ext )
                               then removeFile dir
                               else return ()
                        removeFiles'' dirs ext


                       
removeFile' file = do
                     exist <- doesFileExist file
                     if exist
                        then removeFile file
                        else return ()
                        
                        
